//@author Joe Romano
//@contact joeromano@gmail.com
//@date 07.18.10
//@brief - accelerationObserver.h - helper class to watch the acceleration sensorson the robot gripper and perform important data storage and manipulation

#include <pr2_hardware_interface/hardware_interface.h>
#include <slipgrip_controller/digitalFilter.h>

#ifndef _ACCELERATION_OBSERVER
#define _ACCELERATION_OBSERVER


class accelerationObserver{
  
  public:
    // functions
    accelerationObserver(pr2_hardware_interface::Accelerometer* accelerometerHandle);    // ctor
    ~accelerationObserver();                                               // default destructor
    void spin();                                                       // method to update sensor data. should run at 1khz
    bool checkPlaceContact(double dAcc);
    double aX, aY, aZ;
    double readingTime;

    digitalFilter *accLPFilt[3];
    bool placeContact;

  private:
    pr2_hardware_interface::Accelerometer* accHandle;

};

#endif // _ACCELERATION_OBSERVER
