#include <pr2_controller_interface/controller.h>
#include <pr2_mechanism_model/joint.h>
#include <pr2_hardware_interface/hardware_interface.h>
#include "slipgrip_controller/rtstorage.h"
#include "slipgrip_controller/GripperSensorData.h"
#include "slipgrip_controller/AccelerationSensorData.h"

namespace contact_observer{

class ContactObserverClass: public pr2_controller_interface::Controller
{
private:
  // functions
  bool initializeHandles(pr2_mechanism_model::RobotState *robot, ros::NodeHandle &n);
  void record();

  // The data storage
  control::RTStorage<slipgrip_controller::GripperSensorData> storage_;
  control::RTStorage<slipgrip_controller::AccelerationSensorData> storageAcc_;

  // variables
  //pr2_mechanism_model::JointState* joint_state_;                // a handle to our joint state
  pr2_hardware_interface::HardwareInterface* hardwareInterface; // a handle to our hardware interface
  pr2_hardware_interface::Accelerometer* accelerometerHandle;             // a handle to our accelerometer
  pr2_hardware_interface::PressureSensor* leftFinger_pressureSensorHandle;       // a handle to our pressure sensor
  pr2_hardware_interface::PressureSensor* rightFinger_pressureSensorHandle;       // a handle to our pressure sensor                                 

  //double init_pos_;
 
  
public:
  virtual bool init(pr2_mechanism_model::RobotState *robot, ros::NodeHandle &n);
  virtual void starting();
  virtual void update();
  virtual void stopping();

};
} 
