%{
*********************************************************************
 *
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *  \author Joe Romano
 *********************************************************************/
%}
%
%  @author Joe Romano
%  @brief Method to load all debugging data from the slipgrip_controller
%  program
%
function [pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename)


% load our data csv file into 'data'
[time1, data1] = rtpload(strcat(myfilename,'_praw.rtp')); 
[ pRaw_left pRaw_right pRawTime] = createPressureMatrix(time1,data1); 



% load our data csv file into 'data'
[time2, data2] = rtpload(strcat(myfilename,'_pfilt.rtp')); 
[ pFilt_left pFilt_right pFiltTime] = createPressureMatrix(time2,data2);
%[ pFilt_left pFilt_right] = hpPressureMatrix( pFilt_left, pFilt_right );

% load acceleration data
[acc_combined accTime] = loadAccelerationRTP(strcat(myfilename,'_acc.rtp'));

% load joint data
[time3, data3] = rtpload(strcat(myfilename,'_joint.rtp')); 
joint_pos = data3.position_;
joint_vel = data3.velocity_;
joint_effort = data3.measured_effort_;
joint_time = data3.mytime;