function [] = showLFPressure(myfilename)

[pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename);
UNITS_PER_N = 1600;

% subsample the pressure like the software would
[pRaw_left_sub pRawTime_sub] = subsamplePressureVector(pRaw_left, pRawTime);
[pRaw_right_sub pRawTime_sub] = subsamplePressureVector(pRaw_right, pRawTime);
[pFilt_left_sub pFiltTime_sub] = subsamplePressureVector(pFilt_left, pFiltTime);
[pFilt_right_sub pFiltTime_sub] = subsamplePressureVector(pFilt_right, pFiltTime);

% convert to Newtons
pFilt_left_sub = pFilt_left_sub/UNITS_PER_N;
pFilt_right_sub = pFilt_right_sub/UNITS_PER_N;
pRaw_right_sub = pRaw_right_sub/UNITS_PER_N;
pRaw_left_sub = pRaw_left_sub/UNITS_PER_N;

% start our time vectors from 0
toffset = pRawTime_sub(1);
pRawTime_sub = pRawTime_sub - toffset;
pFiltTime_sub = pFiltTime_sub - toffset;
accTime = accTime - toffset;
joint_time = joint_time - toffset;
tstart = pRawTime_sub(1);
tend = pRawTime_sub(end);


% create our first figure of 5 subplots

subplot(5,1,1);
plot(joint_time,joint_pos,'b');
ylabel('joint position');
%hold on;
%plot(joint_time,joint_vel,'r');
xlim([ tstart tend ] );


subplot(5,1,2);
plot(accTime,acc_combined+8.0,accTime,(abs(acc_combined(:,1))+ abs(acc_combined(:,2))+ abs(acc_combined(:,3))));
ylabel('acceleration');
%hold on;
%plot(accTime,(acc_combined(:,1)+acc_combined(:,2)+acc_combined(:,3))+10,'y');
xlim([ tstart tend ] );


subplot(5,1,3);
plot(pRawTime_sub,pRaw_left_sub,pRawTime_sub,pRaw_right_sub);
ylabel('raw pressure');
xlim([tstart tend] );

subplot(5,1,4);
plot(pFiltTime_sub,pFilt_left_sub,pFiltTime_sub,pFilt_right_sub);
ylabel('zerod/biased pressure');
xlim([ tstart tend ] );

% create a signal from our raw pressure that represents low-frequency
% oscillation
subplot(5,1,5);
% 0.2 hz butterworth highpass
%[b_hp] = fir1(30,0.2/((1/.041)/2),'high');
% 5 hz butterworth lowpass
[b_lp,a_lp] = butter(1,5/((1/.041)/2));
%[b_lp,a_lp] = cheby1(3,0.5,[0.8/((1/.041)/2),5/((1/.041)/2)]);
%[b_lp] = fir1(20,[0.8/((1/.041)/2),5/((1/.041)/2)]);
% 0.2 hz butterworth lowpass
%[b_lp2,a_lp2] = butter(1,0.5/((1/.041)/2));
lfPressure_right = filter(b_lp,a_lp,pRaw_right_sub);
lfPressure_left = filter(b_lp,a_lp,pRaw_left_sub);
%lfPressure_right = filter(b_lp2,a_lp2,pRaw_right_sub) - lfPressure_right;
%lfPressure_left = filter(b_lp2,a_lp2,pRaw_left_sub) - lfPressure_left;
%lfSum_right = sumAbsPressureVectorFingerpad(lfPressure_right);
%lfSum_left = sumAbsPressureVectorFingerpad(lfPressure_left);
lfSum_right = sumPressureVectorFingerpad(lfPressure_right);
lfSum_left = sumPressureVectorFingerpad(lfPressure_left);
%lfSum_right_filt = filter(b_lp2,a_lp2,lfSum_right)-filter(b_lp,a_lp,lfSum_right);
%lfSum_left_filt = filter(b_lp2,a_lp2,lfSum_left)-filter(b_lp,a_lp,lfSum_left);
%lfSumAbs_right = sumPressureVectorFingerpad(lfPressure_right);
%lfSumAbs_left = sumPressureVectorFingerpad(lfPressure_left);
plot(pRawTime_sub,lfSum_right,pRawTime_sub,lfSum_left);
% now find the 0.5 difference in pressure

