"""autogenerated by genmsg_py from GripperFindContactCommand.msg. Do not edit."""
import roslib.message
import struct


class GripperFindContactCommand(roslib.message.Message):
  _md5sum = "e1b0096f6e9f351cfe05089a06de4eb6"
  _type = "slipgrip_controller/GripperFindContactCommand"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Contact action used to close fingers and find object contacts

# true if you want to zero out the force at the beginning of the
# find contact algorithm.
# NOTE: SHOULD ONLY BE TRUE WHEN BOTH FINGERS ARE TOUCHING NOTHING
bool zero_forces

# the finger contact conditions that determine what our goal is
# 0 = both fingers impact
# 1 = left finger impact
# 2 = right finger impact
# 3 = either finger impact
int16 contacts_desired

# speed to close the gripper in m/s
# values <0 result in default speed
float64 close_speed

# the maximum motor effort level (N) to use
# useful for safety purposes if object does not make contact at fingerpads
# value <0 rseult in unlimited effort
float64 max_effort

# control mode to enter after contact
# true means force control mode using contact force
# false means position control mode using contact position
bool force_control_at_goal
"""
  __slots__ = ['zero_forces','contacts_desired','close_speed','max_effort','force_control_at_goal']
  _slot_types = ['bool','int16','float64','float64','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       zero_forces,contacts_desired,close_speed,max_effort,force_control_at_goal
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperFindContactCommand, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.zero_forces is None:
        self.zero_forces = False
      if self.contacts_desired is None:
        self.contacts_desired = 0
      if self.close_speed is None:
        self.close_speed = 0.
      if self.max_effort is None:
        self.max_effort = 0.
      if self.force_control_at_goal is None:
        self.force_control_at_goal = False
    else:
      self.zero_forces = False
      self.contacts_desired = 0
      self.close_speed = 0.
      self.max_effort = 0.
      self.force_control_at_goal = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_Bh2dB.pack(_x.zero_forces, _x.contacts_desired, _x.close_speed, _x.max_effort, _x.force_control_at_goal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.zero_forces, _x.contacts_desired, _x.close_speed, _x.max_effort, _x.force_control_at_goal,) = _struct_Bh2dB.unpack(str[start:end])
      self.zero_forces = bool(self.zero_forces)
      self.force_control_at_goal = bool(self.force_control_at_goal)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_Bh2dB.pack(_x.zero_forces, _x.contacts_desired, _x.close_speed, _x.max_effort, _x.force_control_at_goal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.zero_forces, _x.contacts_desired, _x.close_speed, _x.max_effort, _x.force_control_at_goal,) = _struct_Bh2dB.unpack(str[start:end])
      self.zero_forces = bool(self.zero_forces)
      self.force_control_at_goal = bool(self.force_control_at_goal)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_Bh2dB = struct.Struct("<Bh2dB")
