"""autogenerated by genmsg_py from GripperFindContactResult.msg. Do not edit."""
import roslib.message
import struct

import slipgrip_controller.msg
import roslib.msg

class GripperFindContactResult(roslib.message.Message):
  _md5sum = "3ef5b3345c61ff78dc2b30575a431f90"
  _type = "slipgrip_controller/GripperFindContactResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#results
GripperFindContactData data

================================================================================
MSG: slipgrip_controller/GripperFindContactData
Header header

# the finger contact conditions 
# true if the finger experienced a contact event
bool left_contact
bool right_contact

# the state of our contact. 
# true when the contact has been held long enough to be considered stable
bool stable_contact

# the current force experinced by the finger Pads 
# NOTE:this ignores data from the edges of the finger pressure
float64 left_pad_force
float64 right_pad_force


# the contact force experinced by the finger Pads 
# NOTE:this ignores data from the edges of the finger pressure
# only valid after contact
float64 left_pad_contact_force
float64 right_pad_contact_force

# the contact position at the time of the goal
float64 contact_position

# the current position
float64 current_position

# the motor effort
float64 motor_effort

# the control state of our realtime controller
#  0 - disabled (command zero effort to motors)
#  1 - rezero  (average the data and apply zero offset in real time until leaving this mode)
#  2 - update thresholds (check the current pressure data and update thresholds appropriately)
#  3 - position control mode
#  4 - force control mode
#  5 - find contact mode (either hold force on contact or place into object-pickup mode)
#  6 - slip servo mode
int16 realtime_controller_state

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['data']
  _slot_types = ['slipgrip_controller/GripperFindContactData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       data
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperFindContactResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperFindContactData()
    else:
      self.data = slipgrip_controller.msg.GripperFindContactData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs))
      _x = self.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3B7dh.pack(_x.data.left_contact, _x.data.right_contact, _x.data.stable_contact, _x.data.left_pad_force, _x.data.right_pad_force, _x.data.left_pad_contact_force, _x.data.right_pad_contact_force, _x.data.contact_position, _x.data.current_position, _x.data.motor_effort, _x.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperFindContactData()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 61
      (_x.data.left_contact, _x.data.right_contact, _x.data.stable_contact, _x.data.left_pad_force, _x.data.right_pad_force, _x.data.left_pad_contact_force, _x.data.right_pad_contact_force, _x.data.contact_position, _x.data.current_position, _x.data.motor_effort, _x.data.realtime_controller_state,) = _struct_3B7dh.unpack(str[start:end])
      self.data.left_contact = bool(self.data.left_contact)
      self.data.right_contact = bool(self.data.right_contact)
      self.data.stable_contact = bool(self.data.stable_contact)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs))
      _x = self.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3B7dh.pack(_x.data.left_contact, _x.data.right_contact, _x.data.stable_contact, _x.data.left_pad_force, _x.data.right_pad_force, _x.data.left_pad_contact_force, _x.data.right_pad_contact_force, _x.data.contact_position, _x.data.current_position, _x.data.motor_effort, _x.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperFindContactData()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 61
      (_x.data.left_contact, _x.data.right_contact, _x.data.stable_contact, _x.data.left_pad_force, _x.data.right_pad_force, _x.data.left_pad_contact_force, _x.data.right_pad_contact_force, _x.data.contact_position, _x.data.current_position, _x.data.motor_effort, _x.data.realtime_controller_state,) = _struct_3B7dh.unpack(str[start:end])
      self.data.left_contact = bool(self.data.left_contact)
      self.data.right_contact = bool(self.data.right_contact)
      self.data.stable_contact = bool(self.data.stable_contact)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_3B7dh = struct.Struct("<3B7dh")
