"""autogenerated by genmsg_py from GripperSlipServoActionResult.msg. Do not edit."""
import roslib.message
import struct

import roslib.rostime
import roslib.msg
import actionlib_msgs.msg
import slipgrip_controller.msg

class GripperSlipServoActionResult(roslib.message.Message):
  _md5sum = "511fefc8745d8bbe21ed09ce737eb57e"
  _type = "slipgrip_controller/GripperSlipServoActionResult"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GripperSlipServoResult result

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: slipgrip_controller/GripperSlipServoResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

#result

# our result value that indicates why the goal state occured
GripperSlipServoData data


================================================================================
MSG: slipgrip_controller/GripperSlipServoData
# Data returned from the SlipServo action
Header header

# the amount of object deformation (in meters)
float64 deformation

# the fingersensor grip force (in N)
# this is the average of left/right fingerpads
float64 fingerpad_force

# the current motor effort (in N)
float64 motor_effort

# true if the object recently slipped
bool slip

# true if we are at or exceeding the deformation limit
bool deformation_limit

# true if we are at or exceeding our force limit
bool force_limit

# true if the controller thinks the object was dropped
bool dropped

# the control state of our realtime controller
#  0 - disabled (command zero effort to motors)
#  1 - rezero  (average the data and apply zero offset in real time until leaving this mode)
#  2 - update thresholds (check the current pressure data and update thresholds appropriately)
#  3 - position control mode
#  4 - force control mode
#  5 - find contact mode (either hold force on contact or place into object-pickup mode) 
#  6 - slip servo mode
int16 realtime_controller_state
"""
  __slots__ = ['header','status','result']
  _slot_types = ['Header','actionlib_msgs/GoalStatus','slipgrip_controller/GripperSlipServoResult']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,status,result
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperSlipServoActionResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.status is None:
        self.status = actionlib_msgs.msg.GoalStatus()
      if self.result is None:
        self.result = slipgrip_controller.msg.GripperSlipServoResult()
    else:
      self.header = roslib.msg._Header.Header()
      self.status = actionlib_msgs.msg.GoalStatus()
      self.result = slipgrip_controller.msg.GripperSlipServoResult()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.status.goal_id.stamp.secs, _x.status.goal_id.stamp.nsecs))
      _x = self.status.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.status.status))
      _x = self.status.text
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.result.data.header.seq, _x.result.data.header.stamp.secs, _x.result.data.header.stamp.nsecs))
      _x = self.result.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d4Bh.pack(_x.result.data.deformation, _x.result.data.fingerpad_force, _x.result.data.motor_effort, _x.result.data.slip, _x.result.data.deformation_limit, _x.result.data.force_limit, _x.result.data.dropped, _x.result.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.status is None:
        self.status = actionlib_msgs.msg.GoalStatus()
      if self.result is None:
        self.result = slipgrip_controller.msg.GripperSlipServoResult()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.status.goal_id.stamp.secs, _x.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status.text = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.result.data.header.seq, _x.result.data.header.stamp.secs, _x.result.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.result.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 30
      (_x.result.data.deformation, _x.result.data.fingerpad_force, _x.result.data.motor_effort, _x.result.data.slip, _x.result.data.deformation_limit, _x.result.data.force_limit, _x.result.data.dropped, _x.result.data.realtime_controller_state,) = _struct_3d4Bh.unpack(str[start:end])
      self.result.data.slip = bool(self.result.data.slip)
      self.result.data.deformation_limit = bool(self.result.data.deformation_limit)
      self.result.data.force_limit = bool(self.result.data.force_limit)
      self.result.data.dropped = bool(self.result.data.dropped)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.status.goal_id.stamp.secs, _x.status.goal_id.stamp.nsecs))
      _x = self.status.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.status.status))
      _x = self.status.text
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.result.data.header.seq, _x.result.data.header.stamp.secs, _x.result.data.header.stamp.nsecs))
      _x = self.result.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d4Bh.pack(_x.result.data.deformation, _x.result.data.fingerpad_force, _x.result.data.motor_effort, _x.result.data.slip, _x.result.data.deformation_limit, _x.result.data.force_limit, _x.result.data.dropped, _x.result.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.status is None:
        self.status = actionlib_msgs.msg.GoalStatus()
      if self.result is None:
        self.result = slipgrip_controller.msg.GripperSlipServoResult()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.status.goal_id.stamp.secs, _x.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status.text = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.result.data.header.seq, _x.result.data.header.stamp.secs, _x.result.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.result.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 30
      (_x.result.data.deformation, _x.result.data.fingerpad_force, _x.result.data.motor_effort, _x.result.data.slip, _x.result.data.deformation_limit, _x.result.data.force_limit, _x.result.data.dropped, _x.result.data.realtime_controller_state,) = _struct_3d4Bh.unpack(str[start:end])
      self.result.data.slip = bool(self.result.data.slip)
      self.result.data.deformation_limit = bool(self.result.data.deformation_limit)
      self.result.data.force_limit = bool(self.result.data.force_limit)
      self.result.data.dropped = bool(self.result.data.dropped)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_B = struct.Struct("<B")
_struct_3d4Bh = struct.Struct("<3d4Bh")
_struct_2I = struct.Struct("<2I")
