"""autogenerated by genmsg_py from GripperSlipServoGoal.msg. Do not edit."""
import roslib.message
import struct

import slipgrip_controller.msg

class GripperSlipServoGoal(roslib.message.Message):
  _md5sum = "2570426be6437a72e12dc59f138f9a3a"
  _type = "slipgrip_controller/GripperSlipServoGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Action to launch the gripper into slip servoing mode 
# returns when one of the various goal limitations have been met

#goals
GripperSlipServoCommand command

================================================================================
MSG: slipgrip_controller/GripperSlipServoCommand
# command to send to SlipServo action

# the maximum allowed object deformation (in meters) measured from the starting position of the action call
# a deformation value < 0 results in unlimited deformation
float64 deformation_limit

# the fingertip force (in Newtons) to start the slipServoing method at.
# a force value < 0 results in using the default value of the currently applied force
# note that this is the average grip force (average of left and right fingertip forces)
float64 fingertip_start_force

# the maximum amount of fingertip force (in Newtons) to apply.
# values < 0 indicate no limit on the fingertip force applied
float64 fingertip_force_limit

# the maximum amount of joint effort to allow (in Newtons)
# values < 0 indicate no limit on the motor effort appliedd
# NOTE: This is useful as a safety precaution in case the object does not contact
# the pressure sensors on the fingerpad
float64 max_effort


"""
  __slots__ = ['command']
  _slot_types = ['slipgrip_controller/GripperSlipServoCommand']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       command
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperSlipServoGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = slipgrip_controller.msg.GripperSlipServoCommand()
    else:
      self.command = slipgrip_controller.msg.GripperSlipServoCommand()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_4d.pack(_x.command.deformation_limit, _x.command.fingertip_start_force, _x.command.fingertip_force_limit, _x.command.max_effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.command is None:
        self.command = slipgrip_controller.msg.GripperSlipServoCommand()
      end = 0
      _x = self
      start = end
      end += 32
      (_x.command.deformation_limit, _x.command.fingertip_start_force, _x.command.fingertip_force_limit, _x.command.max_effort,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_4d.pack(_x.command.deformation_limit, _x.command.fingertip_start_force, _x.command.fingertip_force_limit, _x.command.max_effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.command is None:
        self.command = slipgrip_controller.msg.GripperSlipServoCommand()
      end = 0
      _x = self
      start = end
      end += 32
      (_x.command.deformation_limit, _x.command.fingertip_start_force, _x.command.fingertip_force_limit, _x.command.max_effort,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_4d = struct.Struct("<4d")
