"""autogenerated by genmsg_py from GripperSlipServoResult.msg. Do not edit."""
import roslib.message
import struct

import slipgrip_controller.msg
import roslib.msg

class GripperSlipServoResult(roslib.message.Message):
  _md5sum = "2827488fb53e38156bd2ac5c6e1d0443"
  _type = "slipgrip_controller/GripperSlipServoResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

#result

# our result value that indicates why the goal state occured
GripperSlipServoData data


================================================================================
MSG: slipgrip_controller/GripperSlipServoData
# Data returned from the SlipServo action
Header header

# the amount of object deformation (in meters)
float64 deformation

# the fingersensor grip force (in N)
# this is the average of left/right fingerpads
float64 fingerpad_force

# the current motor effort (in N)
float64 motor_effort

# true if the object recently slipped
bool slip

# true if we are at or exceeding the deformation limit
bool deformation_limit

# true if we are at or exceeding our force limit
bool force_limit

# true if the controller thinks the object was dropped
bool dropped

# the control state of our realtime controller
#  0 - disabled (command zero effort to motors)
#  1 - rezero  (average the data and apply zero offset in real time until leaving this mode)
#  2 - update thresholds (check the current pressure data and update thresholds appropriately)
#  3 - position control mode
#  4 - force control mode
#  5 - find contact mode (either hold force on contact or place into object-pickup mode) 
#  6 - slip servo mode
int16 realtime_controller_state
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['data']
  _slot_types = ['slipgrip_controller/GripperSlipServoData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       data
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperSlipServoResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperSlipServoData()
    else:
      self.data = slipgrip_controller.msg.GripperSlipServoData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs))
      _x = self.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d4Bh.pack(_x.data.deformation, _x.data.fingerpad_force, _x.data.motor_effort, _x.data.slip, _x.data.deformation_limit, _x.data.force_limit, _x.data.dropped, _x.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperSlipServoData()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 30
      (_x.data.deformation, _x.data.fingerpad_force, _x.data.motor_effort, _x.data.slip, _x.data.deformation_limit, _x.data.force_limit, _x.data.dropped, _x.data.realtime_controller_state,) = _struct_3d4Bh.unpack(str[start:end])
      self.data.slip = bool(self.data.slip)
      self.data.deformation_limit = bool(self.data.deformation_limit)
      self.data.force_limit = bool(self.data.force_limit)
      self.data.dropped = bool(self.data.dropped)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs))
      _x = self.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d4Bh.pack(_x.data.deformation, _x.data.fingerpad_force, _x.data.motor_effort, _x.data.slip, _x.data.deformation_limit, _x.data.force_limit, _x.data.dropped, _x.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperSlipServoData()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 30
      (_x.data.deformation, _x.data.fingerpad_force, _x.data.motor_effort, _x.data.slip, _x.data.deformation_limit, _x.data.force_limit, _x.data.dropped, _x.data.realtime_controller_state,) = _struct_3d4Bh.unpack(str[start:end])
      self.data.slip = bool(self.data.slip)
      self.data.deformation_limit = bool(self.data.deformation_limit)
      self.data.force_limit = bool(self.data.force_limit)
      self.data.dropped = bool(self.data.dropped)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_3d4Bh = struct.Struct("<3d4Bh")
